import titanium from '../root';
import db from '../db';
import { TitaniumQuery } from '../../../src';

const getAuthorPosts = new TitaniumQuery({
  name: 'getAuthorPosts',
  description: 'Posts made by a single author',
  type: 'connection',
  ofType: 'post',
  args: {
    // @TODO: args here are supressing connection args
    authorId: 'id'
  },
  resolve: (__, { authorId }) => db.postsByAuthor(authorId)
});

// we apply the new type definition to the Titanium main schema
titanium.addQuery(getAuthorPosts);
