import titanium from '../root';
import db from '../db';
import { TitaniumObjectType } from '../../../src';

const authorType = new TitaniumObjectType({
  name: 'Author',
  description: 'An Author inside a blog',
  isTypeOf: node => (node.__type === 'author'),
  fields: {
    id: 'id',
    name: 'string',
    email: 'string',
    createdContent: {
      type: 'connection',
      ofType: 'content',
      resolve: node => db.contentByAuthor(node.id)
    },
    latestContent: {
      type: 'reference',
      ofType: 'content',
      resolve: node => db.contentByAuthor(node.id)[0]
    }
  },
  interfaces: [ 'Node' ],
  resolveAll: () => db.authors
});

// we apply the new type definition to the Titanium main schema
titanium.addType(authorType);
