import titanium from '../root';
import db from '../db';
import { TitaniumObjectType } from '../../../src';

const commentType = new TitaniumObjectType({
  name: 'Comment',
  description: 'A comment on a blog Post',
  isTypeOf: node => (node.__type === 'comment'),
  fields: {
    id: 'id',
    content: 'string',
    date: 'datetime',
    author: {
      type: 'reference',
      ofType: 'author',
      resolve: node => db.getAuthorById(node.author)
    }
  },
  interfaces: [ 'Node' ],
  resolveAll: () => db.comments
});

// we apply the new type definition to the Titanium main schema
titanium.addType(commentType);
