import titanium from '../root';
import { TitaniumQuery } from '../../../src';

const beginsWithAuthor = new TitaniumQuery({
  name: 'beginsWithAuthor',
  description: `Will only spit data out if the arg 'str' begins with author`,
  type: 'string',
  args: {
    str: 'string'
  },
  resolve: (__, { str }) => str
});

beginsWithAuthor.setInputRules({
  str: {
    validate: /author/i
  }
});

titanium.addQuery(beginsWithAuthor);
