import titanium from '../root';
import { TitaniumQuery } from '../../../src';

const spacesForDashes = new TitaniumQuery({
  name: 'spacesForDashes',
  description: `Will change all spaces on arg 'str' for dashes`,
  type: 'string',
  args: {
    str: 'string'
  },
  resolve: (__, { str }) => str
});

spacesForDashes.setInputRules({
  str: {
    sanitize: '$newData.val().split(" ").join("-")'
  }
});

titanium.addQuery(spacesForDashes);
