import Koa from 'koa';
import mount from 'koa-mount';
import graphqlHTTP from 'koa-graphql';

import titanium from './root';

import './schema';
import './queries';

// resolve the schema and convert it to GraphQL
const schema = titanium.getSchema();

const app = Koa();

app.use(
  mount(
    '/',
    graphqlHTTP(request => ({
      schema,
      graphiql: true,
      context: titanium.getContext({
        request,
        user: {
          id: 1
        }
      }),
      formatError: titanium.formatError
    }))
  )
);

const examplePort = process.env.PORT || 3000;
app.listen(examplePort, () => {
  console.log(
    `Ready to rock! ` +
    `Open http://localhost:${examplePort}/ at your browser.`
  );
});
