'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.wrapFieldRules = undefined;

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { return step("next", value); }, function (err) { return step("throw", err); }); } } return step("next"); }); }; }

var wrapFieldRules = exports.wrapFieldRules = function wrapFieldRules(_ref) {
  var fieldResolve = _ref.fieldResolve;
  var fieldName = _ref.fieldName;
  var typeRules = _ref.typeRules;

  var checkAccess = function checkAccess(node, context) {
    if (!typeRules.isReadable(node, context, fieldName)) {
      context.tql.throw(403, 'Access violation: Current viewer has no ' + ('privilege to \'read\' on field \'' + fieldName + '\''));
    }

    return true;
  };

  var wrappedFieldResolve = function () {
    var ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(node, args, context, info) {
      return regeneratorRuntime.wrap(function _callee$(_context) {
        while (1) {
          switch (_context.prev = _context.next) {
            case 0:
              (0, _invariant2.default)(typeof context !== 'undefined', 'wrappedResolve expects \'context\' to be set at a single request');

              (0, _invariant2.default)(typeof context.user !== 'undefined', 'wrappedResolve expects an \'user\' field inside \'context\'');

              _context.next = 4;
              return checkAccess(node, context);

            case 4:
              if (!_context.sent) {
                _context.next = 8;
                break;
              }

              _context.next = 7;
              return fieldResolve(node, args, context, info);

            case 7:
              return _context.abrupt('return', _context.sent);

            case 8:
              return _context.abrupt('return', null);

            case 9:
            case 'end':
              return _context.stop();
          }
        }
      }, _callee, undefined);
    }));

    return function wrappedFieldResolve(_x, _x2, _x3, _x4) {
      return ref.apply(this, arguments);
    };
  }();

  return wrappedFieldResolve;
};