'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createConnectionType = undefined;

var _graphqlRelay = require('graphql-relay');

var createConnectionType = exports.createConnectionType = function createConnectionType(_ref) {
  var typeDefinitions = _ref.typeDefinitions;
  var type = _ref.type;

  // here we get two types of GraphQL objects provided by
  // Relay: connectionType and edgeType
  // * edgeType refers to this type of node inside a connectionType
  // * connectionType refers to the connection itself.

  var _connectionDefinition = (0, _graphqlRelay.connectionDefinitions)({
    name: type,
    nodeType: typeDefinitions[type]
  });

  var connectionType = _connectionDefinition.connectionType;
  var edgeType = _connectionDefinition.edgeType;

  // make those two brand new objects available to the main query

  return {
    connectionType: connectionType,
    connectionArgs: _graphqlRelay.connectionArgs,
    edgeType: edgeType
  };
};