'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _graphql = require('graphql');

var _graphqlRelay = require('graphql-relay');

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _fieldMapper = require('../conversion/fieldMapper');

var _acl = require('../acl');

var _acl2 = _interopRequireDefault(_acl);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TitaniumMutation = function () {
  function TitaniumMutation(config) {
    _classCallCheck(this, TitaniumMutation);

    var name = config.name;
    var _config$description = config.description;
    var description = _config$description === undefined ? '' : _config$description;
    var inputFields = config.inputFields;
    var outputFields = config.outputFields;
    var resolve = config.resolve;
    var inputRules = config.inputRules;
    var outputRules = config.outputRules;


    (0, _invariant2.default)(typeof name === 'string', 'TitaniumMutation(constructor) expects \'name\' to be of type \'String\'' + (' received \'' + (typeof name === 'undefined' ? 'undefined' : _typeof(name)) + '\' instead'));

    (0, _invariant2.default)((typeof inputFields === 'undefined' ? 'undefined' : _typeof(inputFields)) === 'object' && !Array.isArray(inputFields), 'TitaniumMutation(constructor) expects \'inputFields\' to be of type ' + ('\'object\', received \'' + (typeof inputFields === 'undefined' ? 'undefined' : _typeof(inputFields)) + '\' instead'));

    (0, _invariant2.default)((typeof outputFields === 'undefined' ? 'undefined' : _typeof(outputFields)) === 'object' && !Array.isArray(outputFields), 'TitaniumMutation(constructor) expects \'outputFields\' to be of type ' + ('\'object\', received \'' + (typeof outputFields === 'undefined' ? 'undefined' : _typeof(outputFields)) + '\' instead'));

    (0, _invariant2.default)(typeof resolve === 'function', 'TitaniumMutation(constructor) expects \'resolve\' to be of type ' + ('\'function\', received \'' + (typeof resolve === 'undefined' ? 'undefined' : _typeof(resolve)) + '\' instead'));

    this.name = name;
    this.description = description;
    this.resolve = resolve;

    this.setInputFields(inputFields);
    this.setOutputFields(outputFields);

    if (inputRules) {
      this.setInputRules(inputRules);
    }

    if (outputRules) {
      this.setOutputRules(outputRules);
    }
  }

  _createClass(TitaniumMutation, [{
    key: 'setInputFields',
    value: function setInputFields(fields) {
      if (!(fields instanceof Object)) {
        throw new TypeError('Value of argument "fields" violates contract.\n\nExpected:\nObject\n\nGot:\n' + _inspect(fields));
      }

      (0, _invariant2.default)((typeof fields === 'undefined' ? 'undefined' : _typeof(fields)) === 'object' && !Array.isArray(fields), 'setInputFields expects \'fields\' to be of type \'object\', ' + ('received \'' + (typeof fields === 'undefined' ? 'undefined' : _typeof(fields)) + '\' instead'));

      this.rawInputFields = fields;
    }
  }, {
    key: 'setOutputFields',
    value: function setOutputFields(fields) {
      if (!(fields instanceof Object)) {
        throw new TypeError('Value of argument "fields" violates contract.\n\nExpected:\nObject\n\nGot:\n' + _inspect(fields));
      }

      (0, _invariant2.default)((typeof fields === 'undefined' ? 'undefined' : _typeof(fields)) === 'object' && !Array.isArray(fields), 'setOutputFields expects \'fields\' to be of type \'object\', ' + ('received \'' + (typeof fields === 'undefined' ? 'undefined' : _typeof(fields)) + '\' instead'));

      this.rawOutputFields = fields;
    }
  }, {
    key: 'setInputRules',
    value: function setInputRules(rules) {
      if (!(rules instanceof Object)) {
        throw new TypeError('Value of argument "rules" violates contract.\n\nExpected:\nObject\n\nGot:\n' + _inspect(rules));
      }

      if (typeof this._mutationInputRules !== 'undefined') {
        console.warn('Warning: Rules for mutation \'' + this.name + '\' are being ' + 'overwritten. It may cause unexpected results');
      }

      this._mutationInputRules = new _acl2.default(rules);
    }
  }, {
    key: 'setOutputRules',
    value: function setOutputRules(rules) {
      if (!(rules instanceof Object)) {
        throw new TypeError('Value of argument "rules" violates contract.\n\nExpected:\nObject\n\nGot:\n' + _inspect(rules));
      }

      if (typeof this._mutationOutputRules !== 'undefined') {
        console.warn('Warning: Output rules for mutation \'' + this.name + '\' are being ' + 'overwritten. It may cause unexpected results');
      }

      this._mutationOutputRules = new _acl2.default(rules);
    }
  }, {
    key: '_toGraphQL',
    value: function _toGraphQL(typeDefinitionList) {
      var _this = this;

      function _ref5(_id5) {
        if (!(_id5 instanceof _graphql.GraphQLObjectType)) {
          throw new TypeError('Function return value violates contract.\n\nExpected:\nGraphQLObjectType\n\nGot:\n' + _inspect(_id5));
        }

        return _id5;
      }

      if (!(typeDefinitionList instanceof Object)) {
        throw new TypeError('Value of argument "typeDefinitionList" violates contract.\n\nExpected:\nObject\n\nGot:\n' + _inspect(typeDefinitionList));
      }

      (0, _invariant2.default)((typeof typeDefinitionList === 'undefined' ? 'undefined' : _typeof(typeDefinitionList)) === 'object' && !Array.isArray(typeDefinitionList), '_toGraphQL expects typeDefinitionList to be of type \'object\', ' + ('received \'' + (typeof typeDefinitionList === 'undefined' ? 'undefined' : _typeof(typeDefinitionList)) + '\' instead'));

      var outputObj = (0, _graphqlRelay.mutationWithClientMutationId)({
        name: this.name,
        description: this.description,

        inputFields: function inputFields() {
          return _lodash2.default.mapValues(_this.rawInputFields, function (fieldDefinition, fieldName) {
            return (0, _fieldMapper.fieldMapper)({
              typeDefinitionList: typeDefinitionList,
              fieldName: fieldName,
              fieldDefinition: fieldDefinition,
              name: _this.name,
              fieldRules: _this._mutationInputRule
            });
          });
        },

        outputFields: function outputFields() {
          return _lodash2.default.mapValues(_this.rawOutputFields, function (fieldDefinition, fieldName) {
            return (0, _fieldMapper.fieldMapper)({
              typeDefinitionList: typeDefinitionList,
              fieldName: fieldName,
              fieldDefinition: fieldDefinition,
              name: _this.name,
              fieldRules: _this._mutationOutputRules
            });
          });
        },

        mutateAndGetPayload: function mutateAndGetPayload(args, context, info) {
          if (_this._mutationInputRules) {
            var filteredArgs = Object.keys(args).reduce(function (curr, key) {
              if (_this._mutationInputRules) {
                var currentUserCanWrite = _this._mutationInputRules.isWritable(args, context, key);

                if (!currentUserCanWrite) {
                  context.tql.throw(403, 'Access violation: Current writer does not have ' + ('permissions to input \'' + args[key] + '\' on \'' + key + '\''));
                }

                var isFieldValid = _this._mutationInputRules.validate(args, context, key);

                if (!isFieldValid) {
                  context.tql.throw(403, 'Validation Error: Malformed input \'' + args[key] + '\' for key ' + ('\'' + key + '\'. Please check the API documentation for more ') + 'details.');
                }

                curr[key] = _this._mutationInputRules.sanitize(args, context, key);
              } else {
                curr[key] = args[key];
              }

              return curr;
            }, {});

            return Promise.resolve(_this.resolve(filteredArgs, context, info));
          }

          return Promise.resolve(_this.resolve(args, context, info));
        }
      });

      return _ref5(outputObj);
    }
  }]);

  return TitaniumMutation;
}();

exports.default = TitaniumMutation;

function _inspect(input, depth) {
  var maxDepth = 4;
  var maxKeys = 15;

  if (depth === undefined) {
    depth = 0;
  }

  depth += 1;

  if (input === null) {
    return 'null';
  } else if (input === undefined) {
    return 'void';
  } else if (typeof input === 'string' || typeof input === 'number' || typeof input === 'boolean') {
    return typeof input === 'undefined' ? 'undefined' : _typeof(input);
  } else if (Array.isArray(input)) {
    if (input.length > 0) {
      var _ret = function () {
        if (depth > maxDepth) return {
            v: '[...]'
          };

        var first = _inspect(input[0], depth);

        if (input.every(function (item) {
          return _inspect(item, depth) === first;
        })) {
          return {
            v: first.trim() + '[]'
          };
        } else {
          return {
            v: '[' + input.slice(0, maxKeys).map(function (item) {
              return _inspect(item, depth);
            }).join(', ') + (input.length >= maxKeys ? ', ...' : '') + ']'
          };
        }
      }();

      if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
    } else {
      return 'Array';
    }
  } else {
    var keys = Object.keys(input);

    if (!keys.length) {
      if (input.constructor && input.constructor.name && input.constructor.name !== 'Object') {
        return input.constructor.name;
      } else {
        return 'Object';
      }
    }

    if (depth > maxDepth) return '{...}';
    var indent = '  '.repeat(depth - 1);
    var entries = keys.slice(0, maxKeys).map(function (key) {
      return (/^([A-Z_$][A-Z0-9_$]*)$/i.test(key) ? key : JSON.stringify(key)) + ': ' + _inspect(input[key], depth) + ';';
    }).join('\n  ' + indent);

    if (keys.length >= maxKeys) {
      entries += '\n  ' + indent + '...';
    }

    if (input.constructor && input.constructor.name && input.constructor.name !== 'Object') {
      return input.constructor.name + ' {\n  ' + indent + entries + '\n' + indent + '}';
    } else {
      return '{\n  ' + indent + entries + '\n' + indent + '}';
    }
  }
}