'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _graphql = require('graphql');

var _graphqlRelay = require('graphql-relay');

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _type = require('../conversion/type');

var _acl = require('../acl');

var _acl2 = _interopRequireDefault(_acl);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TitaniumQuery = function () {
  function TitaniumQuery(_ref3) {
    var name = _ref3.name;
    var _ref3$description = _ref3.description;
    var description = _ref3$description === undefined ? '' : _ref3$description;
    var type = _ref3.type;
    var ofType = _ref3.ofType;
    var args = _ref3.args;
    var resolve = _ref3.resolve;

    _classCallCheck(this, TitaniumQuery);

    (0, _invariant2.default)(typeof name === 'string', 'TitaniumQuery(constructor) expects \'name\' to be of type \'String\', ' + ('received \'' + (typeof name === 'undefined' ? 'undefined' : _typeof(name)) + '\' instead'));

    (0, _invariant2.default)(typeof resolve === 'function', 'TitaniumQuery(constructor) expects \'resolve\' to be of type ' + ('\'function\', received \'' + (typeof resolve === 'undefined' ? 'undefined' : _typeof(resolve)) + '\' instead'));

    if (args) {
      (0, _invariant2.default)((typeof args === 'undefined' ? 'undefined' : _typeof(args)) === 'object' && !Array.isArray(args), 'TitaniumQuery(constructor) expects \'args\' to be of type \'object\', ' + ('received \'' + (typeof args === 'undefined' ? 'undefined' : _typeof(args)) + '\' instead'));

      this.args = args;
    }

    this.name = name;
    this.description = description;

    this.type = type;
    this.ofType = ofType;

    this.resolve = resolve;

    this.idArgs = [];
  }

  _createClass(TitaniumQuery, [{
    key: 'setInputRules',
    value: function setInputRules(rules) {
      if (!(rules instanceof Object)) {
        throw new TypeError('Value of argument "rules" violates contract.\n\nExpected:\nObject\n\nGot:\n' + _inspect(rules));
      }

      this._inputRules = new _acl2.default(rules);
    }
  }, {
    key: '_toGraphQL',
    value: function _toGraphQL(typeDefinitionList) {
      var _this = this;

      if (!(typeDefinitionList instanceof Object)) {
        throw new TypeError('Value of argument "typeDefinitionList" violates contract.\n\nExpected:\nObject\n\nGot:\n' + _inspect(typeDefinitionList));
      }

      var returnObject = {
        name: this.name,
        description: this.description
      };

      // type defined, we should map them too.
      var typeDefinition = {
        type: this.type,
        ofType: this.ofType
      };

      returnObject.type = (0, _type.convertType)({
        typeName: this.name,
        typeDefinitionList: typeDefinitionList,
        fieldName: this.name,
        fieldDefinition: typeDefinition
      });

      // if the query has args, we should also map the fields
      if (this.args) {
        returnObject.args = _lodash2.default.mapValues(this.args, function (fieldDefinition, fieldName) {
          var argType = (0, _type.convertType)({
            typeName: _this.name,
            typeDefinitionList: typeDefinitionList,
            fieldName: fieldName,
            fieldDefinition: fieldDefinition,
            ignoreIDFieldName: true
          });

          if (argType === 'id') {
            _this.idArgs.push(fieldName);
            argType = new _graphql.GraphQLNonNull(_graphql.GraphQLID);
          }

          return { type: argType };
        });
      }

      if (this.type === 'connection') {
        returnObject.args = returnObject.args || {};

        var intersection = _lodash2.default.intersection(Object.keys(returnObject.args), Object.keys(_graphqlRelay.connectionArgs));

        (0, _invariant2.default)(intersection.length === 0, 'Warning: Some defined args for query ' + this.name + ' will be ' + 'overwritten by connection args!');

        _lodash2.default.assign(returnObject.args, _graphqlRelay.connectionArgs);
      }

      // the resolve function of the query is mandatory.
      // otherwise it would be impossible to know what to do with it.
      (0, _invariant2.default)(this.resolve, 'Query \'' + this.name + '\' does not have a resolver');

      returnObject.resolve = function (__, args, context, info) {
        var filteredArgs = Object.keys(args).reduce(function (curr, key) {
          if (_this._inputRules) {
            var currentUserCanWrite = _this._inputRules.isWritable(args, context, key);

            if (!currentUserCanWrite) {
              context.tql.throw(403, 'Access violation: Current writer does not have permissions ' + (' to input data on \'' + key + '\''));
            }

            var isFieldValid = _this._inputRules.validate(args, context, key);

            if (!isFieldValid) {
              context.tql.throw(403, 'Validation Error: Malformed input for key \'' + key + '\'. ' + 'Please check the documentation');
            }

            if (_this.idArgs.indexOf(key) === -1) {
              curr[key] = _this._inputRules.sanitize(args, context, key);
            }
          } else {
            curr[key] = args[key];
          }

          // if it is an ID type field, convert it from globalId
          if (_this.idArgs.indexOf(key) !== -1) {
            curr[key] = (0, _graphqlRelay.fromGlobalId)(args[key]).id;
          }

          return curr;
        }, {});

        return Promise.resolve(_this.resolve(__, filteredArgs, context, info));
      };

      return returnObject;
    }
  }]);

  return TitaniumQuery;
}();

exports.default = TitaniumQuery;

function _inspect(input, depth) {
  var maxDepth = 4;
  var maxKeys = 15;

  if (depth === undefined) {
    depth = 0;
  }

  depth += 1;

  if (input === null) {
    return 'null';
  } else if (input === undefined) {
    return 'void';
  } else if (typeof input === 'string' || typeof input === 'number' || typeof input === 'boolean') {
    return typeof input === 'undefined' ? 'undefined' : _typeof(input);
  } else if (Array.isArray(input)) {
    if (input.length > 0) {
      var _ret = function () {
        if (depth > maxDepth) return {
            v: '[...]'
          };

        var first = _inspect(input[0], depth);

        if (input.every(function (item) {
          return _inspect(item, depth) === first;
        })) {
          return {
            v: first.trim() + '[]'
          };
        } else {
          return {
            v: '[' + input.slice(0, maxKeys).map(function (item) {
              return _inspect(item, depth);
            }).join(', ') + (input.length >= maxKeys ? ', ...' : '') + ']'
          };
        }
      }();

      if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
    } else {
      return 'Array';
    }
  } else {
    var keys = Object.keys(input);

    if (!keys.length) {
      if (input.constructor && input.constructor.name && input.constructor.name !== 'Object') {
        return input.constructor.name;
      } else {
        return 'Object';
      }
    }

    if (depth > maxDepth) return '{...}';
    var indent = '  '.repeat(depth - 1);
    var entries = keys.slice(0, maxKeys).map(function (key) {
      return (/^([A-Z_$][A-Z0-9_$]*)$/i.test(key) ? key : JSON.stringify(key)) + ': ' + _inspect(input[key], depth) + ';';
    }).join('\n  ' + indent);

    if (keys.length >= maxKeys) {
      entries += '\n  ' + indent + '...';
    }

    if (input.constructor && input.constructor.name && input.constructor.name !== 'Object') {
      return input.constructor.name + ' {\n  ' + indent + entries + '\n' + indent + '}';
    } else {
      return '{\n  ' + indent + entries + '\n' + indent + '}';
    }
  }
}