'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _graphql = require('graphql');

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _fieldMapper = require('../../conversion/fieldMapper');

var _acl = require('../../acl');

var _acl2 = _interopRequireDefault(_acl);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TitaniumObjectType = function () {
  function TitaniumObjectType(options) {
    _classCallCheck(this, TitaniumObjectType);

    var name = options.name;
    var _options$description = options.description;
    var description = _options$description === undefined ? '' : _options$description;
    var _options$fields = options.fields;
    var fields = _options$fields === undefined ? {} : _options$fields;
    var _options$interfaces = options.interfaces;
    var interfaces = _options$interfaces === undefined ? [] : _options$interfaces;
    var resolveAll = options.resolveAll;
    var isTypeOf = options.isTypeOf;
    var _options$createHelper = options.createHelpers;
    var createHelpers = _options$createHelper === undefined ? true : _options$createHelper;
    var outputRules = options.outputRules;


    (0, _invariant2.default)(typeof name === 'string', 'TitaniumObjectType(constructor) expects \'name\' to be of type ' + ('\'String\', received \'' + (typeof name === 'undefined' ? 'undefined' : _typeof(name)) + '\' instead'));

    (0, _invariant2.default)(!name.endsWith('Connection') && !name.endsWith('Edge'), 'Titanium reserves the use of type names ending with Connection ' + ('and Edge for relay helpers. Please choose another name for \'' + name + '\'.'));

    if (createHelpers) {
      (0, _invariant2.default)(typeof resolveAll === 'function', 'Your Type \'' + name + '\' allows helpers to be created, however, ' + 'a required \'resolveAll\' function was not found or is not of the ' + 'expected type');
    }

    this.name = name;
    this.description = description;
    this.resolveAll = resolveAll;
    this.createHelpers = createHelpers;

    this.setFields(fields);
    this.setInterfaces(interfaces);

    if (isTypeOf) {
      this.setResolveType(isTypeOf);
    }

    if (outputRules) {
      this.setOutputRules(outputRules);
    }
  }

  _createClass(TitaniumObjectType, [{
    key: 'setResolveType',
    value: function setResolveType(isTypeOf) {
      if (!(typeof isTypeOf === 'function')) {
        throw new TypeError('Value of argument "isTypeOf" violates contract.\n\nExpected:\nFunction\n\nGot:\n' + _inspect(isTypeOf));
      }

      (0, _invariant2.default)(typeof isTypeOf === 'function', 'setResolveType expects \'isTypeOf\' to be of type \'function\', ' + ('received \'' + (typeof isTypeOf === 'undefined' ? 'undefined' : _typeof(isTypeOf)) + '\' instead'));

      this.isTypeOf = isTypeOf;
    }
  }, {
    key: 'setFields',
    value: function setFields(fields) {
      if (!(fields instanceof Object)) {
        throw new TypeError('Value of argument "fields" violates contract.\n\nExpected:\nObject\n\nGot:\n' + _inspect(fields));
      }

      (0, _invariant2.default)((typeof fields === 'undefined' ? 'undefined' : _typeof(fields)) === 'object' && !Array.isArray(fields), 'setFields expects \'fields\' to be of type \'object\', ' + ('received \'' + (typeof fields === 'undefined' ? 'undefined' : _typeof(fields)) + '\' instead'));

      this.rawFields = fields;
    }
  }, {
    key: 'setInterfaces',
    value: function setInterfaces(interfaces) {
      if (!Array.isArray(interfaces)) {
        throw new TypeError('Value of argument "interfaces" violates contract.\n\nExpected:\nArray\n\nGot:\n' + _inspect(interfaces));
      }

      (0, _invariant2.default)(Array.isArray(interfaces), 'setInterfaces expects \'interfaces\' to be of type ' + ('\'Array instance\', received \'' + (typeof interfaces === 'undefined' ? 'undefined' : _typeof(interfaces)) + '\' instead'));

      this.interfaces = interfaces;
    }
  }, {
    key: 'addInterface',
    value: function addInterface(newInterface) {
      if (!(typeof newInterface === 'string')) {
        throw new TypeError('Value of argument "newInterface" violates contract.\n\nExpected:\nstring\n\nGot:\n' + _inspect(newInterface));
      }

      (0, _invariant2.default)(typeof newInterface === 'string', 'addInterface expects newInterface to be of type \'String\', ' + ('received \'' + (typeof newInterface === 'undefined' ? 'undefined' : _typeof(newInterface)) + '\' instead'));

      this.interfaces.push(newInterface);
    }
  }, {
    key: 'setOutputRules',
    value: function setOutputRules(rules) {
      if (!(rules instanceof Object)) {
        throw new TypeError('Value of argument "rules" violates contract.\n\nExpected:\nObject\n\nGot:\n' + _inspect(rules));
      }

      if (typeof this._typeRules !== 'undefined') {
        console.warn('Warning: Output rules for type \'' + this.name + '\' are being ' + 'overwritten. It may cause unexpected results');
      }

      this._typeRules = new _acl2.default(rules);
    }
  }, {
    key: '_toGraphQL',
    value: function _toGraphQL(typeDefinitionList) {
      if (!(typeDefinitionList instanceof Object)) {
        throw new TypeError('Value of argument "typeDefinitionList" violates contract.\n\nExpected:\nObject\n\nGot:\n' + _inspect(typeDefinitionList));
      }

      (0, _invariant2.default)((typeof typeDefinitionList === 'undefined' ? 'undefined' : _typeof(typeDefinitionList)) === 'object' && !Array.isArray(typeDefinitionList), '_toGraphQL expects typeDefinitionList to be of type \'object\', ' + ('received \'' + (typeof typeDefinitionList === 'undefined' ? 'undefined' : _typeof(typeDefinitionList)) + '\' instead'));

      var fieldMapper = new _fieldMapper.TitaniumFieldMapper({
        typeName: this.name,
        typeFields: this.rawFields,
        typeRules: this._typeRules
      });

      var outputObject = new _graphql.GraphQLObjectType({
        name: this.name,
        description: this.description,

        isTypeOf: this.isTypeOf,

        fields: function fields() {
          return fieldMapper._toGraphQL(typeDefinitionList);
        },

        interfaces: this.interfaces
      });

      outputObject.__rawTitanium = this;

      return outputObject;
    }
  }]);

  return TitaniumObjectType;
}();

exports.default = TitaniumObjectType;

function _inspect(input, depth) {
  var maxDepth = 4;
  var maxKeys = 15;

  if (depth === undefined) {
    depth = 0;
  }

  depth += 1;

  if (input === null) {
    return 'null';
  } else if (input === undefined) {
    return 'void';
  } else if (typeof input === 'string' || typeof input === 'number' || typeof input === 'boolean') {
    return typeof input === 'undefined' ? 'undefined' : _typeof(input);
  } else if (Array.isArray(input)) {
    if (input.length > 0) {
      var _ret = function () {
        if (depth > maxDepth) return {
            v: '[...]'
          };

        var first = _inspect(input[0], depth);

        if (input.every(function (item) {
          return _inspect(item, depth) === first;
        })) {
          return {
            v: first.trim() + '[]'
          };
        } else {
          return {
            v: '[' + input.slice(0, maxKeys).map(function (item) {
              return _inspect(item, depth);
            }).join(', ') + (input.length >= maxKeys ? ', ...' : '') + ']'
          };
        }
      }();

      if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
    } else {
      return 'Array';
    }
  } else {
    var keys = Object.keys(input);

    if (!keys.length) {
      if (input.constructor && input.constructor.name && input.constructor.name !== 'Object') {
        return input.constructor.name;
      } else {
        return 'Object';
      }
    }

    if (depth > maxDepth) return '{...}';
    var indent = '  '.repeat(depth - 1);
    var entries = keys.slice(0, maxKeys).map(function (key) {
      return (/^([A-Z_$][A-Z0-9_$]*)$/i.test(key) ? key : JSON.stringify(key)) + ': ' + _inspect(input[key], depth) + ';';
    }).join('\n  ' + indent);

    if (keys.length >= maxKeys) {
      entries += '\n  ' + indent + '...';
    }

    if (input.constructor && input.constructor.name && input.constructor.name !== 'Object') {
      return input.constructor.name + ' {\n  ' + indent + entries + '\n' + indent + '}';
    } else {
      return '{\n  ' + indent + entries + '\n' + indent + '}';
    }
  }
}