'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _graphql = require('graphql');

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TitaniumUnionType = function () {
  function TitaniumUnionType(options) {
    _classCallCheck(this, TitaniumUnionType);

    var name = options.name;
    var _options$description = options.description;
    var description = _options$description === undefined ? '' : _options$description;
    var ofTypes = options.ofTypes;


    (0, _invariant2.default)(typeof name === 'string', 'TitaniumUnionType(constructor) expects \'name\' to be of type ' + ('\'String\', received \'' + (typeof name === 'undefined' ? 'undefined' : _typeof(name)) + '\' instead'));

    (0, _invariant2.default)(!name.endsWith('Connection') && !name.endsWith('Edge'), 'Titanium reserves the use of type names ending with Connection ' + ('and Edge for relay helpers. Please choose another name for \'' + name + '\'.'));

    this.name = name;
    this.description = description;

    // @TODO: add invariant for check validity of this arg
    this.types = ofTypes;
  }

  _createClass(TitaniumUnionType, [{
    key: 'mapTypes',
    value: function mapTypes(typeDefinitionList) {
      function _ref(_id) {
        if (!Array.isArray(_id)) {
          throw new TypeError('Function return value violates contract.\n\nExpected:\nArray\n\nGot:\n' + _inspect(_id));
        }

        return _id;
      }

      if (!(typeDefinitionList instanceof Object)) {
        throw new TypeError('Value of argument "typeDefinitionList" violates contract.\n\nExpected:\nObject\n\nGot:\n' + _inspect(typeDefinitionList));
      }

      return _ref(_lodash2.default.map(this.types, function (type) {
        return typeDefinitionList[type];
      }));
    }
  }, {
    key: '_toGraphQL',
    value: function _toGraphQL(typeDefinitionList) {
      if (!(typeDefinitionList instanceof Object)) {
        throw new TypeError('Value of argument "typeDefinitionList" violates contract.\n\nExpected:\nObject\n\nGot:\n' + _inspect(typeDefinitionList));
      }

      (0, _invariant2.default)((typeof typeDefinitionList === 'undefined' ? 'undefined' : _typeof(typeDefinitionList)) === 'object' && !Array.isArray(typeDefinitionList), '_toGraphQL expects typeDefinitionList to be of type \'object\', ' + ('received \'' + (typeof typeDefinitionList === 'undefined' ? 'undefined' : _typeof(typeDefinitionList)) + '\' instead'));

      var outputObject = new _graphql.GraphQLUnionType({
        name: this.name,
        description: this.description,

        types: this.mapTypes(typeDefinitionList)
      });

      outputObject.__rawTitanium = this;

      return outputObject;
    }
  }]);

  return TitaniumUnionType;
}();

exports.default = TitaniumUnionType;

function _inspect(input, depth) {
  var maxDepth = 4;
  var maxKeys = 15;

  if (depth === undefined) {
    depth = 0;
  }

  depth += 1;

  if (input === null) {
    return 'null';
  } else if (input === undefined) {
    return 'void';
  } else if (typeof input === 'string' || typeof input === 'number' || typeof input === 'boolean') {
    return typeof input === 'undefined' ? 'undefined' : _typeof(input);
  } else if (Array.isArray(input)) {
    if (input.length > 0) {
      var _ret = function () {
        if (depth > maxDepth) return {
            v: '[...]'
          };

        var first = _inspect(input[0], depth);

        if (input.every(function (item) {
          return _inspect(item, depth) === first;
        })) {
          return {
            v: first.trim() + '[]'
          };
        } else {
          return {
            v: '[' + input.slice(0, maxKeys).map(function (item) {
              return _inspect(item, depth);
            }).join(', ') + (input.length >= maxKeys ? ', ...' : '') + ']'
          };
        }
      }();

      if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
    } else {
      return 'Array';
    }
  } else {
    var keys = Object.keys(input);

    if (!keys.length) {
      if (input.constructor && input.constructor.name && input.constructor.name !== 'Object') {
        return input.constructor.name;
      } else {
        return 'Object';
      }
    }

    if (depth > maxDepth) return '{...}';
    var indent = '  '.repeat(depth - 1);
    var entries = keys.slice(0, maxKeys).map(function (key) {
      return (/^([A-Z_$][A-Z0-9_$]*)$/i.test(key) ? key : JSON.stringify(key)) + ': ' + _inspect(input[key], depth) + ';';
    }).join('\n  ' + indent);

    if (keys.length >= maxKeys) {
      entries += '\n  ' + indent + '...';
    }

    if (input.constructor && input.constructor.name && input.constructor.name !== 'Object') {
      return input.constructor.name + ' {\n  ' + indent + entries + '\n' + indent + '}';
    } else {
      return '{\n  ' + indent + entries + '\n' + indent + '}';
    }
  }
}