'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var isTypeOf = function isTypeOf(type) {
  return function (object) {
    var label = object.labels[0];

    return label.toLowerCase() === type.toLowerCase();
  };
};

var idResolver = function idResolver(node) {
  return node.uuid;
};

var fieldResolver = function fieldResolver(fieldName) {
  return function (node) {
    return node.properties[fieldName];
  };
};

var idField = {
  type: 'id',
  resolve: idResolver
};

exports.isTypeOf = isTypeOf;
exports.idResolver = idResolver;
exports.fieldResolver = fieldResolver;
exports.idField = idField;