'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Titanium = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _graphql = require('graphql');

var _graphqlRelay = require('graphql-relay');

var _graphqlErrors = require('graphql-errors');

var _dataloader = require('dataloader');

var _dataloader2 = _interopRequireDefault(_dataloader);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _invariant = require('invariant');

var _invariant2 = _interopRequireDefault(_invariant);

var _pluralize = require('pluralize');

var _pluralize2 = _interopRequireDefault(_pluralize);

var _object = require('./definitions/types/object');

var _object2 = _interopRequireDefault(_object);

var _union = require('./definitions/types/union');

var _union2 = _interopRequireDefault(_union);

var _interface = require('./definitions/interface');

var _interface2 = _interopRequireDefault(_interface);

var _query = require('./definitions/query');

var _query2 = _interopRequireDefault(_query);

var _mutation = require('./definitions/mutation');

var _mutation2 = _interopRequireDefault(_mutation);

var _acl = require('./acl');

var _datastore = require('./datastore');

var _datastore2 = _interopRequireDefault(_datastore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Titanium = exports.Titanium = function () {
  function Titanium(config) {
    _classCallCheck(this, Titanium);

    var _config$rootQuery = config.rootQuery;
    var rootQuery = _config$rootQuery === undefined ? {} : _config$rootQuery;
    var rootMutation = config.rootMutation;
    var _config$userContextPa = config.userContextPath;
    var userContextPath = _config$userContextPa === undefined ? 'session' : _config$userContextPa;
    var nodeResolver = config.nodeResolver;


    if (nodeResolver) {
      (0, _invariant2.default)(typeof nodeResolver === 'function', 'Titanium(constructor) expects \'nodeResolver\' to be of type ' + ('\'function\', received \'' + (typeof nodeResolver === 'undefined' ? 'undefined' : _typeof(nodeResolver)) + '\' instead'));
    }

    this.types = {};
    this.interfaces = {};
    this.queries = {};
    this.mutations = {};
    this.stores = {};

    this.rootQuery = function (typeDefinitionList) {
      return new _graphql.GraphQLObjectType({
        // we allow the customization of the rootQuery name and description
        name: rootQuery.name || 'RootQuery',
        description: rootQuery.description || 'The root app Query',

        // here goes the rootQuery fields
        fields: function fields() {
          return _extends({
            // remember Relay's nodeInterface that queries any node type
            // by its globalId? That's it.
            node: typeDefinitionList.nodeField

          }, typeDefinitionList.rootQueryFields);
        }
      });
    };

    if (rootMutation) {
      this.rootMutation = function (typeDefinitionList) {
        return new _graphql.GraphQLObjectType({
          name: rootMutation.name || 'RootMutation',
          description: rootQuery.description || 'The root app Mutation',

          fields: function fields() {
            return typeDefinitionList.rootMutationFields;
          }
        });
      };
    }

    this.nodeResolver = nodeResolver;
    this.userContextPath = userContextPath;
  }

  _createClass(Titanium, [{
    key: 'addType',
    value: function addType(type) {
      if (!(type instanceof _object2.default || type instanceof _union2.default)) {
        throw new TypeError('Value of argument "type" violates contract.\n\nExpected:\nTitaniumObjectType | TitaniumUnionType\n\nGot:\n' + _inspect(type));
      }

      (0, _invariant2.default)(type instanceof _object2.default || type instanceof _union2.default, 'addSchema expects \'type\' to be instance of TitaniumObjectType');

      (0, _invariant2.default)(typeof this.types[type.name.toLowerCase()] === 'undefined', 'There is already a Schema with name \'' + type.name + '\'');

      this.types[type.name.toLowerCase()] = type;
    }
  }, {
    key: 'addQuery',
    value: function addQuery(query) {
      if (!(query instanceof _query2.default)) {
        throw new TypeError('Value of argument "query" violates contract.\n\nExpected:\nTitaniumQuery\n\nGot:\n' + _inspect(query));
      }

      (0, _invariant2.default)(query instanceof _query2.default, 'addQuery expects \'query\' to be instance of TitaniumQuery');

      (0, _invariant2.default)(typeof this.queries[query.name] === 'undefined', 'There is already a Query with name \'' + query.name + '\'');

      this.queries[query.name] = query;
    }
  }, {
    key: 'addMutation',
    value: function addMutation(mutation) {
      if (!(mutation instanceof _mutation2.default)) {
        throw new TypeError('Value of argument "mutation" violates contract.\n\nExpected:\nTitaniumMutation\n\nGot:\n' + _inspect(mutation));
      }

      (0, _invariant2.default)(mutation instanceof _mutation2.default, 'addMutation expects \'mutation\' to be instance of TitaniumMutation');

      (0, _invariant2.default)(typeof this.mutations[mutation.name] === 'undefined', 'There is already a Mutation with name \'' + mutation.name + '\'');

      this.mutations[mutation.name] = mutation;
    }
  }, {
    key: 'addInterface',
    value: function addInterface(newInterface) {
      if (!(newInterface instanceof _interface2.default)) {
        throw new TypeError('Value of argument "newInterface" violates contract.\n\nExpected:\nTitaniumInterface\n\nGot:\n' + _inspect(newInterface));
      }

      (0, _invariant2.default)(newInterface instanceof _interface2.default, 'addInterface expects newInterface to be of type \'TitaniumInterface\', ' + ('received \'' + (typeof newInterface === 'undefined' ? 'undefined' : _typeof(newInterface)) + '\' instead'));

      // @TODO: invariant of already existing interface
      var normalizedName = newInterface._rawInterface.name.toLowerCase();
      this.interfaces[normalizedName] = newInterface._toGraphQL();
    }
  }, {
    key: 'addStoreStrategy',
    value: function addStoreStrategy(strategy) {
      if (!(strategy instanceof Object)) {
        throw new TypeError('Value of argument "strategy" violates contract.\n\nExpected:\nObject\n\nGot:\n' + _inspect(strategy));
      }

      (0, _invariant2.default)((typeof strategy === 'undefined' ? 'undefined' : _typeof(strategy)) === 'object' && !Array.isArray(strategy), 'addStoreStrategy expects \'strategy\' to be instance ' + 'of TitaniumStoreStrategy');

      (0, _invariant2.default)(typeof this.stores[strategy.name] === 'undefined', 'Warning: There already is a Store Strategy with name \'' + strategy.name + '\'');

      this.stores[strategy.name] = new _datastore2.default(strategy);
    }
  }, {
    key: 'spawnLoaders',
    value: function spawnLoaders() {
      var _this = this;

      function _ref6(_id6) {
        if (!(_id6 instanceof Object)) {
          throw new TypeError('Function return value violates contract.\n\nExpected:\nObject<DataLoader>\n\nGot:\n' + _inspect(_id6));
        }

        return _id6;
      }

      return _ref6(Object.keys(this.stores).reduce(function (curr, key) {
        curr[key] = _this.stores[key].getNewInstance();
        return curr;
      }, {}));
    }
  }, {
    key: 'getContext',
    value: function getContext() {
      var customContext = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

      function _ref7(_id7) {
        if (!(_id7 instanceof Object)) {
          throw new TypeError('Function return value violates contract.\n\nExpected:\nObject\n\nGot:\n' + _inspect(_id7));
        }

        return _id7;
      }

      if (!(customContext instanceof Object)) {
        throw new TypeError('Value of argument "customContext" violates contract.\n\nExpected:\nObject\n\nGot:\n' + _inspect(customContext));
      }

      return _ref7(_lodash2.default.assign(customContext, {
        // namespaced context to prevent future collisions with user created
        // context keys
        tql: {
          stores: this.spawnLoaders(),

          throw: function _throw(status, message) {
            var errMessage = message;
            var errStatus = status;

            if (!errMessage) {
              errMessage = status;
              errStatus = 500;
            }

            var err = new _graphqlErrors.UserError(errMessage);
            err.status = errStatus;
            throw err;
          }
        }
      }));
    }
  }, {
    key: 'formatError',
    value: function formatError(error) {
      console.error(error.stack);

      return {
        code: error.originalError ? error.originalError.status || 1 : 1,
        message: error.message,
        locations: error.locations
      };
    }
  }, {
    key: 'getSchema',
    value: function getSchema() {
      var typeDefinitionList = this.resolveSchemaQueries();

      var rawSchema = {
        query: this.rootQuery(typeDefinitionList)
      };

      if (this.rootMutation) {
        rawSchema.mutation = this.rootMutation(typeDefinitionList);
      }

      var schema = new _graphql.GraphQLSchema(rawSchema);

      // we mask errors here since GraphQL usually spits out the whole error
      (0, _graphqlErrors.maskErrors)(schema);

      return schema;
    }
  }, {
    key: 'resolveSchemaQueries',
    value: function resolveSchemaQueries() {
      var _this2 = this;

      // we create here, using Relay's helper nodeDefinitions
      // how to deal with the globalObjectId after creating the relay
      // interface, we destruct the returning object into two vars

      var _nodeDefinitions = (0, _graphqlRelay.nodeDefinitions)(function (globalId, context, info) {
        // the fromGlobalId function breaks the base64 encoded ID into the type
        // for example, the type would be 'user' and id would be the user ID
        // inside the database table 'Users'

        var _fromGlobalId = (0, _graphqlRelay.fromGlobalId)(globalId);

        var type = _fromGlobalId.type;
        var id = _fromGlobalId.id;


        if (typeof _this2.types[type] === 'undefined') {
          _this2.throw(400, 'Malformed ID input for \'node\' field');
        }

        // then we return this type and id to the main mapper provided by the
        // Titanium instance created. This mapper is provided by the user on
        // Titanium's instantiation by the config key nodeResolver
        if (_this2.types[type]._typeRules !== 'undefined') {
          // @TODO: wtf is happening here? should be acl?
          // I don't think that this needs to be here since the nodeResolver
          // has the acl built-in
          return _this2.nodeResolver(type, id, context, info);
        }

        return _this2.nodeResolver(type, id, context, info);
      });

      var nodeInterface = _nodeDefinitions.nodeInterface;
      var nodeField = _nodeDefinitions.nodeField;

      // here we run through all available object types and manipulate
      // them accordigly to its nature typeDefinitionList holds all the
      // references, so we can use it to refer to other objects inside types
      // (such as connection ans reference types)

      var typeDefinitionList = {};
      var rootQueryFields = {};
      var rootMutationFields = {};
      var titaniumHelperQueries = {};

      var types = Object.keys(this.types).reduce(function (acc, key) {
        // variable declaration
        var changedName = void 0;

        // we need to convert field to graphQL type it is a TitaniumObjectType
        if (_this2.types[key] instanceof _object2.default) {
          // use use only lowercase type names throughout the app
          changedName = _this2.types[key].name.toLowerCase();

          if (_this2.types[key].interfaces.length > 0) {
            (0, _invariant2.default)(typeof _this2.types[key].isTypeOf === 'function', 'Your type \'' + key + '\' implements interfaces, however it does not' + 'have a \'isTypeOf\' method available. This way it won\'t be ' + 'possible to resolve a node of this type at runtime');
          }

          // here we apply all the built-in interfaces (such as Node)
          _this2.types[key].interfaces = _lodash2.default.map(_this2.types[key].interfaces, function (value) {
            if (value.toLowerCase() === 'node') {
              return nodeInterface;
            }

            return _this2.types[value];
          });

          // convert the type to graphql and apply
          // to a list of available object types
          acc[changedName] = _this2.types[key]._toGraphQL(acc);
        } else if (_this2.types[key] instanceof _union2.default) {
          changedName = _this2.types[key].name.toLowerCase();
          acc[changedName] = _this2.types[key]._toGraphQL(acc);
        } else {
          // we do not want to change the rootQuery
          // or rootMutation capitalization
          changedName = key;

          // apply the object references inside those types
          acc[changedName] = _this2.types[key](acc);
        }

        // second step is to add features to the Titanium Types
        // we make this check because we are also looping through rootQuery
        // and rootMutation, fields that should not be converted.
        if (_this2.types[key] instanceof _object2.default || _this2.types[key] instanceof _union2.default) {
          // this is the relay specific implementation of connections and edges
          var connectionName = changedName + 'Connection';
          var edgeName = changedName + 'Edge';
          var pluralName = _this2.types[key].pluralName || (0, _pluralize2.default)(changedName);

          // here we get two types of GraphQL objects provided by
          // Relay: connectionType and edgeType
          // * edgeType refers to this type of node inside a connectionType
          // * connectionType refers to the connection itself.

          var _connectionDefinition = (0, _graphqlRelay.connectionDefinitions)({
            name: _this2.types[key].name,
            nodeType: acc[changedName]
          });

          var connectionType = _connectionDefinition.connectionType;
          var edgeType = _connectionDefinition.edgeType;

          // make those two brand new objects available to the main query

          acc[connectionName] = connectionType;
          acc[edgeName] = edgeType;

          // here we add a pluralized name to the root query, in order
          // to return all related objects of this type. you may not want
          // every single object to be listed, so you can disable it by
          // changing the createHelpers flag to false
          if (_this2.types[key].createHelpers !== false) {
            (function () {
              var fieldResolver = _this2.types[key].resolveAll;
              var relayResolver = function relayResolver(node, args, context, info) {
                return (0, _graphqlRelay.connectionFromPromisedArray)(Promise.resolve(fieldResolver(node, args, context, info)), args);
              };

              titaniumHelperQueries[pluralName] = {
                type: connectionType,
                args: _graphqlRelay.connectionArgs
              };

              if (_this2.types[key]._typeRules) {
                titaniumHelperQueries[pluralName].resolve = (0, _acl.wrapFieldRules)({
                  fieldResolve: relayResolver,
                  fieldName: pluralName,
                  typeRules: _this2.types[key]._typeRules
                });
              } else {
                titaniumHelperQueries[pluralName].resolve = relayResolver;
              }
            })();
          }
        }

        // return the current object at reduce
        return acc;
      }, _extends({
        // we start the typeDefinitionList object with the nodeInterface and
        // nodeField ready to go.
        nodeInterface: nodeInterface,
        nodeField: nodeField
      }, this.interfaces));

      // reduce through mutations applied by addMutation
      rootMutationFields = Object.keys(this.mutations).reduce(function (current, key) {
        // we normalize the key here to start with a lowcase letter
        var normalizedKey = key.charAt(0).toLowerCase() + key.slice(1);
        current[normalizedKey] = _this2.mutations[key]._toGraphQL(types);

        return current;
      }, {});

      rootQueryFields = Object.keys(this.queries).reduce(function (current, key) {
        var normalizedKey = key.charAt(0).toLowerCase() + key.slice(1);
        current[normalizedKey] = _this2.queries[key]._toGraphQL(types);

        return current;
      }, titaniumHelperQueries);

      typeDefinitionList = _extends({}, types, {
        rootQueryFields: rootQueryFields,
        rootMutationFields: rootMutationFields
      });

      // after all the mapping and converting journey,
      // we can return own beautiful graphql type definition list!
      return typeDefinitionList;
    }
  }]);

  return Titanium;
}();

function _inspect(input, depth) {
  var maxDepth = 4;
  var maxKeys = 15;

  if (depth === undefined) {
    depth = 0;
  }

  depth += 1;

  if (input === null) {
    return 'null';
  } else if (input === undefined) {
    return 'void';
  } else if (typeof input === 'string' || typeof input === 'number' || typeof input === 'boolean') {
    return typeof input === 'undefined' ? 'undefined' : _typeof(input);
  } else if (Array.isArray(input)) {
    if (input.length > 0) {
      var _ret2 = function () {
        if (depth > maxDepth) return {
            v: '[...]'
          };

        var first = _inspect(input[0], depth);

        if (input.every(function (item) {
          return _inspect(item, depth) === first;
        })) {
          return {
            v: first.trim() + '[]'
          };
        } else {
          return {
            v: '[' + input.slice(0, maxKeys).map(function (item) {
              return _inspect(item, depth);
            }).join(', ') + (input.length >= maxKeys ? ', ...' : '') + ']'
          };
        }
      }();

      if ((typeof _ret2 === 'undefined' ? 'undefined' : _typeof(_ret2)) === "object") return _ret2.v;
    } else {
      return 'Array';
    }
  } else {
    var keys = Object.keys(input);

    if (!keys.length) {
      if (input.constructor && input.constructor.name && input.constructor.name !== 'Object') {
        return input.constructor.name;
      } else {
        return 'Object';
      }
    }

    if (depth > maxDepth) return '{...}';
    var indent = '  '.repeat(depth - 1);
    var entries = keys.slice(0, maxKeys).map(function (key) {
      return (/^([A-Z_$][A-Z0-9_$]*)$/i.test(key) ? key : JSON.stringify(key)) + ': ' + _inspect(input[key], depth) + ';';
    }).join('\n  ' + indent);

    if (keys.length >= maxKeys) {
      entries += '\n  ' + indent + '...';
    }

    if (input.constructor && input.constructor.name && input.constructor.name !== 'Object') {
      return input.constructor.name + ' {\n  ' + indent + entries + '\n' + indent + '}';
    } else {
      return '{\n  ' + indent + entries + '\n' + indent + '}';
    }
  }
}