'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _objectDestructuringEmpty(obj) { if (obj == null) throw new TypeError("Cannot destructure undefined"); }

function getField(node, fieldName) {
  // @TODO: this is product centric (neo4j), we should decouple this

  if (node[fieldName]) {
    return node[fieldName];
  } else if (node.properties) {
    return node.properties[fieldName];
  }

  return null;
}

var TitaniumResolver = exports.TitaniumResolver = function TitaniumResolver(returnType) {
  if (returnType === 'regular') {
    return function (node, args, context, _ref) {
      var fieldName = _ref.fieldName;
      return getField(node, fieldName);
    };
  } else if (returnType === 'id') {
    return function (node, context, _ref2) {
      var fieldName = _ref2.fieldName;
      return getField(node, fieldName);
    };
  } else if (returnType === 'datetime') {
    return function (node, _ref3, context, _ref4) {
      var fieldName = _ref4.fieldName;

      _objectDestructuringEmpty(_ref3);

      return new Date(getField(node, fieldName)).toISOString();
    };
  } else if (returnType === 'dateonly') {
    return function (node, _ref5, context, _ref6) {
      var fieldName = _ref6.fieldName;

      _objectDestructuringEmpty(_ref5);

      return new Date(getField(node, fieldName)).toISOString().substr(0, 10);
    };
  } else if (returnType === 'time') {
    return function (node, _ref7, context, _ref8) {
      var fieldName = _ref8.fieldName;

      _objectDestructuringEmpty(_ref7);

      return new Date(getField(node, fieldName)).toISOString().substr(11, 19);
    };
  }
};